-----------------------------------------------------------------------------------------------------
-- Inicio Script 14 Junio 2012 Carolina Olarte 	                                                   --
-- Ajuste para el menu de copias de seguridad no presente erro                                     --
-----------------------------------------------------------------------------------------------------

update menu
set enlace=NULL
where enlace='NULL'

------------------------------------------------------------------------------------------
-- Fin Script 14 JUNIO 2012 Carolina Olarte	                  	                        --
------------------------------------------------------------------------------------------


-----------------------------------------------------------------------------------------------------
-- Inicio Script 20 Junio 2012 Carolina Olarte 	                                                   --
-- Quitar opcion de menu base de datos completa, porque solo hay una divisin                      --
-----------------------------------------------------------------------------------------------------

delete from paginaperfil
where idPagina in (
SELECT idPagina from pagina 
where idMenu = '04010301' and nombre='Pagina'
)

delete from pagina 
where idMenu = '04010301' and nombre='Pagina'

update pagina 
set idMenu= '040103'
where idMenu = '04010301' and nombre='Backups.aspx'


delete from menu
where idMenu = '04010301'

update menu 
set enlace= '~/audSeguridad/Backups.aspx'
where idMenu = '040103'


------------------------------------------------------------------------------------------
-- Fin Script 20 JUNIO 2012 Carolina Olarte	                  	                        --
------------------------------------------------------------------------------------------

-----------------------------------------------------------------------------------------------------
-- Inicio Script 21 Junio 2012 Carolina Olarte 	                                                   --
-- Tabla con objetivos Predefinidos                                                                --
-----------------------------------------------------------------------------------------------------


--Adicionar el campo idEstudio a la tabla objetivoAuditoria para que las auditoria tipo Modelo proceso de operacion sea por estudio
IF NOT EXISTS(SELECT * FROM information_schema.[columns] WHERE
table_name='ObjetivoAuditoria' AND column_name='idEstudio')
ALTER TABLE [dbo].[ObjetivoAuditoria]
ADD [idEstudio] int  NULL
GO

--Adicionar relacin a la tabla objetivoAuditoria y Estudio
IF NOT EXISTS (SELECT * FROM sysobjects WHERE id = object_id(N'[FK_ObjetivoAuditoria_Estudio]') 
	AND OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[ObjetivoAuditoria]   with nocheck  ADD CONSTRAINT [FK_ObjetivoAuditoria_Estudio] 
FOREIGN KEY ([idEstudio]) REFERENCES [dbo].[Estudio] ([idEstudio]) ON DELETE CASCADE 
go

--Adicion de columna para saber que objetivos se pasaron a la relacion
IF NOT EXISTS(SELECT * FROM information_schema.[columns] WHERE
table_name='ObjetivoSeleccionados' AND column_name='paso')
ALTER TABLE [dbo].[ObjetivoSeleccionados]
ADD [paso] int  NULL
GO


--Tabla para guardar los objetivos predefinidos
CREATE TABLE ObjetivosAuditoriaProcesosPredefinidos
(idObjetivo int IDENTITY (1,1) ,
Descripcion varchar(250),
Detalle varchar(700),
idEmpresa int ,
idTipoAuditoria int
CONSTRAINT idObjetivo_pk PRIMARY KEY (idObjetivo)
)

--Adicionar relacin a la tabla ObjetivosAuditoriaProcesosPredefinidos y Empresa
IF NOT EXISTS (SELECT * FROM sysobjects WHERE id = object_id(N'[FK_ObjetivosAuditoriaProcesosPredefinidos_Empresa]') 
	AND OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[ObjetivosAuditoriaProcesosPredefinidos]   with nocheck  ADD CONSTRAINT [FK_ObjetivosAuditoriaProcesosPredefinidos_Empresa] 
FOREIGN KEY ([idEmpresa]) REFERENCES [dbo].[Empresa] ([idEmpresa]) ON DELETE CASCADE 
go

--Adicionar relacin a la tabla ObjetivosAuditoriaProcesosPredefinidos y TipoAuditoria
IF NOT EXISTS (SELECT * FROM sysobjects WHERE id = object_id(N'[FK_ObjetivosAuditoriaProcesosPredefinidos_TipoAuditoria]') 
	AND OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[ObjetivosAuditoriaProcesosPredefinidos]   with nocheck  ADD CONSTRAINT [FK_ObjetivosAuditoriaProcesosPredefinidos_TipoAuditoria] 
FOREIGN KEY ([idTipoAuditoria]) REFERENCES [dbo].[TipoAuditoria] ([idTipoAuditoria]) ON DELETE CASCADE 
go


set ANSI_NULLS ON
set QUOTED_IDENTIFIER ON
GO

--Procedimienti para agregar objetivos predefinidos por empresa
CREATE PROCEDURE [dbo].[AdicionarObjetivosPredefinidosPorEmpresasLicenciadas] 
AS

DECLARE @idEmpresa AS int
DECLARE @idTipoAuditoria AS int

BEGIN       
	
	DECLARE cur CURSOR LOCAL for
	  SELECT idEmpresa 
	  FROM Empresa  
	  WHERE idEmpresaAuditora IS NULL 


	OPEN cur

	FETCH next FROM cur INTO @idEmpresa

	WHILE @@FETCH_STATUS = 0 BEGIN
		SET @idTipoAuditoria=2
        BEGIN TRANSACTION
		INSERT INTO ObjetivosAuditoriaProcesosPredefinidos (descripcion,detalle,idEmpresa,idTipoAuditoria) VALUES ('Evaluar y verificar que las actividades del proceso se realizan de manera segura, eficiente','Evaluar y verificar que las actividades del proceso se realizan de manera segura, eficiente, confiable, cumplen con las normas legales exigidas y satisfacen apropiadamente las necesidades de la organizacin',@idEmpresa,@idTipoAuditoria)
		INSERT INTO ObjetivosAuditoriaProcesosPredefinidos (descripcion,detalle,idEmpresa,idTipoAuditoria) VALUES ('Identificar y analizar las debilidades, deficiencias y aspectos mejorables en el funcionamiento del proceso','Identificar y analizar las debilidades, deficiencias y aspectos mejorables en el funcionamiento del proceso',@idEmpresa,@idTipoAuditoria)
		INSERT INTO ObjetivosAuditoriaProcesosPredefinidos (descripcion,detalle,idEmpresa,idTipoAuditoria) VALUES ('Informar a la Direccin de la Empresa, los resultados de la auditoria','Informar a la Direccin de la Empresa, los resultados de la auditoria y recomendar las acciones de mejoramiento correspondientes',@idEmpresa,@idTipoAuditoria)
		COMMIT TRANSACTION
	  FETCH next FROM cur INTO @idEmpresa
	END

	CLOSE cur
	DEALLOCATE cur

END 
GO

BEGIN TRANSACTION
EXEC AdicionarObjetivosPredefinidosPorEmpresasLicenciadas
COMMIT TRANSACTION
GO

--PROCEDIMIENTO PARA REASIGNAR OBJETIVOS QUE YA ESTABAN ASIGNADOS
set ANSI_NULLS ON
set QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[ReasignarObjetivosDefinidosPorEstudio] 
AS

DECLARE @idObjetivoAuditoria AS int
DECLARE @idEmpresa AS int
DECLARE @idEstudio AS int
DECLARE @idEstudioOcupado AS int
DECLARE @NuevoObjetivo AS int

BEGIN       
	
	DECLARE cur CURSOR LOCAL for
		SELECT  idObjetivoAuditoria,idEmpresa,idEstudio
		FROM ObjetivoSeleccionados
		WHERE idObjetivoAuditoria IN 
		(
			SELECT idObjetivoAuditoria
			FROM ObjetivoAuditoria
			WHERE idTipoAuditoria= 2
		) 
		AND paso  IS NULL


	OPEN cur

	FETCH next FROM cur INTO @idObjetivoAuditoria,@idEmpresa,@idEstudio

	WHILE @@FETCH_STATUS = 0 BEGIN
         BEGIN TRANSACTION

       
		   SET @idEstudioOcupado = (SELECT idEstudio
									FROM ObjetivoAuditoria
									WHERE idTipoAuditoria= 2 AND idobjetivoauditoria=@idObjetivoAuditoria)
	       
	      
		   IF @idEstudioOcupado is NULL BEGIN
			   UPDATE objetivoAuditoria
			   SET idEstudio=@idEstudio
			   WHERE idObjetivoAuditoria=@idObjetivoAuditoria
	           
			   UPDATE ObjetivoSeleccionados
			   SET  paso= 1
			   WHERE idObjetivoAuditoria=@idObjetivoAuditoria AND idEstudio=@idEstudio

			END 

			ELSE BEGIN
	             
				INSERT INTO objetivoAuditoria (idEmpresa,descripcionObjetivoAud,detalleobjetivoAud,idTipoAuditoria,idEstudio)
				SELECT idEmpresa,descripcionObjetivoAud,detalleobjetivoAud,2,@idEstudio
				FROM ObjetivoAuditoria
				WHERE idTipoAuditoria= 2 AND idobjetivoAuditoria=@idObjetivoAuditoria
				
				SET @NuevoObjetivo = SCOPE_IDENTITY(); 
				
				UPDATE ObjetivoSeleccionados
				SET idObjetivoAuditoria=@NuevoObjetivo, paso= 1
				WHERE idObjetivoAuditoria=@idObjetivoAuditoria and idEstudio=@idEstudio
			END
         COMMIT TRANSACTION

		FETCH next FROM cur INTO @idObjetivoAuditoria,@idEmpresa,@idEstudio
	END

	CLOSE cur
	DEALLOCATE cur

END 
GO

BEGIN TRANSACTION
EXEC ReasignarObjetivosDefinidosPorEstudio
COMMIT TRANSACTION
GO


-- Cambia la forma como se insertan los objetivos de auditoria dependiendo el tipo de auditoria que se este copiando
set ANSI_NULLS ON
set QUOTED_IDENTIFIER ON
GO

ALTER PROCEDURE [dbo].[SP_CreaAuditoriaDesdeAuditoria] (@idEstudio Int, @nombreEstudio VarChar(400), @idUsuario Int) AS
DECLARE @NuevoEstudio Int, @Mensaje VarChar(2000)
DECLARE @TipoAuditoria INT
SET NOCOUNT ON
BEGIN TRY
--- prueba
BEGIN TRANSACTION
-- 07 marzo 2012 
-- Se adiciono un campo al momento de copiar la auditoria se almacene el estudio del que es copiado 'EstudioCopiado' 
    INSERT INTO Estudio (idMacroproceso, idEmpresa, idProcesoEmpresa, idTipoEstudio, nombreEstudio, numeroParticipante, 
            idMonitoreoActual, idTipoMacroproceso, evaluacionDelphy, terminado, FechaCreacion,EstudioCopiado)
    SELECT idMacroproceso, idEmpresa, idProcesoEmpresa, idTipoEstudio, @nombreEstudio, numeroParticipante, idMonitoreoActual, 
            idTipoMacroproceso, evaluacionDelphy, 0, GetDate(),idEstudio
      FROM Estudio
     WHERE idEstudio = @idEstudio

    SET @NuevoEstudio = SCOPE_IDENTITY(); 

-- 07 marzo 2012 
-- Se pasa nulo a los campos idtrabajo y annoFiscal porque lo que se esta haciendo es una copia y este no se incluyo en el plan, se hizo fue una copia 

    INSERT INTO INT_AuditoriaEstudio (idEmpresa, Modulo, idEstudio, idTrabajo, annoFiscal)
    SELECT idEmpresa, Modulo, @NuevoEstudio, NULL, NULL
      FROM INT_AuditoriaEstudio
     WHERE idEstudio = @idEstudio

    INSERT INTO MenuEstados (idMenu, idEmpresa, idEstudio, estado, activo)
    SELECT idMenu, idEmpresa, @NuevoEstudio, 'P', activo
      FROM MenuEstados
     WHERE idEstudio = @idEstudio

     -- Actualiza nicamente la opcin de "Objetivos de la Auditora"
     UPDATE MenuEstados
        SET Estado = 'T'
     WHERE idEstudio = @NuevoEstudio
       AND idMenu < '0404010101'

     UPDATE MenuEstados
        SET Estado = 'E'
     WHERE idEstudio = @NuevoEstudio
       AND idMenu = '0404010101'

    -- Etapa 1.1.1

    SET @TipoAuditoria = (SELECT idTipoEstudio FROM Estudio WHERE idEstudio = @NuevoEstudio )
    IF @TipoAuditoria<>2 BEGIN
    --Si los objetivos son de un estudio diferente a procesos de modelo de operacin entonces solo copia las relaciones
		  INSERT INTO ObjetivoSeleccionados(idObjetivoAuditoria, idEmpresa, idEstudio)
		  SELECT idObjetivoAuditoria, idEmpresa, @NuevoEstudio
		  FROM ObjetivoSeleccionados
		  WHERE idEstudio = @idEstudio
    END
    ELSE  IF @TipoAuditoria=2 BEGIN
      --Si los objetivos son de un estudio a procesos de modelo de operacin entonces solo los objetivos elegibles
          INSERT INTO ObjetivoAuditoria(idEmpresa, descripcionObjetivoAud, detalleObjetivoAud, idTipoAuditoria, idEstudio)
		  SELECT  idEmpresa, descripcionObjetivoAud, detalleObjetivoAud, idTipoAuditoria, @NuevoEstudio
		  FROM ObjetivoAuditoria
		  WHERE idEstudio = @idEstudio
    END

    INSERT INTO Escenario(idEmpresa, descripcionEscenario, detalleEscenario, codigo, idTipoEscenario, idEstudio, idUsuario, idModelo)
    SELECT idEmpresa, descripcionEscenario, detalleEscenario, codigo, idTipoEscenario, @NuevoEstudio, @idUsuario, idModelo
      FROM Escenario
     WHERE idEstudio = @idEstudio

      -- Etapa 1.1.2
    INSERT INTO EstudioEscenario (idEscenario, idEstudio, idRiesgo, opinionDisenador, idProteccionEmpresaMonitoreo, proteccionExistenteMonitoreo, riesgoResidualMonitoreo, idUsuario, idProteccionEmpresaAuditoria, proteccionExistenteAuditoria, riesgoResidualAuditoria)
    SELECT IsNull((SELECT e.idEscenario
               FROM Escenario AS e
             WHERE e.idEstudio = @NuevoEstudio
               AND e.descripcionEscenario = Escenario.descripcionEscenario), EstudioEscenario.idEscenario),
            @NuevoEstudio, EstudioEscenario.idRiesgo, EstudioEscenario.opinionDisenador, EstudioEscenario.idProteccionEmpresaMonitoreo, 
            EstudioEscenario.proteccionExistenteMonitoreo, EstudioEscenario.riesgoResidualMonitoreo, @idUsuario, 
            EstudioEscenario.idProteccionEmpresaAuditoria, EstudioEscenario.proteccionExistenteAuditoria, EstudioEscenario.riesgoResidualAuditoria
      FROM EstudioEscenario
            INNER JOIN Escenario
            ON Escenario.idEscenario = EstudioEscenario.idEscenario
     WHERE EstudioEscenario.idEstudio = @idEstudio

    -- Etapa 1.1.3
    INSERT INTO PuntoInteres (descripcionPunto, idEmpresa, idEstudio)
    SELECT descripcionPunto, idEmpresa, @NuevoEstudio
      FROM PuntoInteres
     WHERE idEstudio = @idEstudio

    -- Etapa 1.1.4
    INSERT INTO DuracionEstimadaAuditoria (idEmpresa, idEstudio, fechaInicial, fechaFinal, horasEstimadas)
    SELECT idEmpresa, @NuevoEstudio, fechaInicial, fechaFinal, horasEstimadas
      FROM DuracionEstimadaAuditoria
     WHERE idEstudio = @idEstudio

--    Se quita este fragmento de codigo porque no se debe copiar los responsables, cada auditora tiene sus responsables
--    -- Etapa 1.1.5
--    INSERT INTO AsignarResponsabilidad (idUsuario, idEmpresa, idEstudio, porcentaje, costoHora)
--    SELECT idUsuario, idEmpresa, @NuevoEstudio, porcentaje, costoHora
--      FROM AsignarResponsabilidad
--     WHERE idEstudio = @idEstudio
--		AND idUsuario NOT IN ( --Esto se adiciona para que no copie si habia usuarios de solo consulta asignados
--			 SELECT DISTINCT asignarresponsabilidad.idUsuario
--			 FROM asignarresponsabilidad
--			 INNER JOIN usuario ON usuario.idUsuario=asignarresponsabilidad.idUsuario
--			 AND asignarresponsabilidad.idEstudio = @idEstudio 
--			 INNER JOIN usuarioEstudio ON 
--			 usuario.idUsuario = usuarioEstudio.idUsuario 
--			 AND asignarresponsabilidad.idUsuario = usuarioEstudio.idUsuario 
--			 INNER JOIN perfil ON 
--			 usuarioEstudio.idPerfil = perfil.idPerfil 
--			 INNER JOIN descripcionModificada ON 
--			 perfil.idDescripcionPerfil = descripcionModificada.idDescripcion 
--			 WHERE usuarioEstudio.idPerfil IN (14)  
--		)

    -- Etapa 1.2.1
    INSERT INTO Etapa (idEtapa, nombreEtapa, porcentaje, horas, idEmpresa, idEstudio)
    SELECT idEtapa, nombreEtapa, porcentaje, horas, idEmpresa, @NuevoEstudio
      FROM Etapa
     WHERE idEstudio = @idEstudio

    -- Etapa 1.2.3
    INSERT INTO OtrosCostos (idEmpresa, idEstudio, descripcion, fechaConsumo, precioUnidad, cantidad)
    SELECT idEmpresa, @NuevoEstudio, descripcion, fechaConsumo, precioUnidad, cantidad
      FROM OtrosCostos
     WHERE idEstudio = @idEstudio

    -- Etapa 1.4.1
    INSERT INTO MotivosAuditoria (idEmpresa, idEstudio, idMotivo, idEtapa)
    SELECT idEmpresa, @NuevoEstudio, idMotivo, idEtapa
      FROM MotivosAuditoria
     WHERE idEstudio = @idEstudio

    -- Etapa 1.4.1
    INSERT INTO AvanceAuditoria (idEmpresa, idEstudio, idEtapa, horasReales)
    SELECT idEmpresa, @NuevoEstudio, idEtapa, horasReales
      FROM AvanceAuditoria
     WHERE idEstudio = @idEstudio
       AND idEtapa < '040405'

-- Se quita este fragmento de codigo porque los auditores asi sea una copia, se vuelven asignar, entonces los tiempor por lo general son diferentes
    -- Etapa 1.4.2
--    INSERT INTO AvanceAuditor (idEmpresa, idEstudio, idEtapa, idAuditor, horasReales)
--    SELECT idEmpresa, @NuevoEstudio, idEtapa, idAuditor, horasReales
--      FROM AvanceAuditor
--     WHERE idEstudio = @idEstudio
--       AND idEtapa < '040405'

    -- Etapa 2.1.1
    INSERT INTO ReferenciaPapelTrabajo (idRequerimiento, medio, referencia, idAuditoria)
    SELECT idRequerimiento, medio, referencia, @NuevoEstudio
      FROM ReferenciaPapelTrabajo
     WHERE idAuditoria = @idEstudio

    INSERT INTO ArchivoPermanenteSeleccionado (idRequerimiento, idEmpresa, idEstudio)
    SELECT idRequerimiento, idEmpresa, @NuevoEstudio
      FROM ArchivoPermanenteSeleccionado
     WHERE idEstudio = @idEstudio

    -- Etapa 2.1.2: si es una auditoria de Procesos
    INSERT INTO Proceso (idEstudio, nombreProceso, objetivoEstudio, inicioEstudio, finEstudio, entradaEstudio, salidaEstudio, 
            proveedorEstudio, clienteEstudio, requerimientoCliente, requerimientoLegal, requerimientoEmpresa, indicador, recurso, 
            metodoSeguimiento, procesoApoyo, documentacionEstudio, idTipoEstudio)
    SELECT @NuevoEstudio, nombreProceso, objetivoEstudio, inicioEstudio, finEstudio, entradaEstudio, salidaEstudio, proveedorEstudio, 
           clienteEstudio, requerimientoCliente, requerimientoLegal, requerimientoEmpresa, indicador, recurso, metodoSeguimiento, 
           procesoApoyo, documentacionEstudio, idTipoEstudio
      FROM Proceso
     WHERE idEstudio = @idEstudio

    -- Si es una auditoria de Aplicaciones
    INSERT INTO Aplicacion (idEstudio, nombreAplicacion, procesoNegocioApoyo, objetivoAplicacion, informacionManeja, 
            entradaAplicacion, salidaAplicacion, proveedorAplicacion, clienteAplicacion, normatividadInterna, normatividadExterna, 
            indicador, fechaInicioProyecto, duracionProyecto, costoProyecto, jefeProyecto, participante, procesamientoPorLotes, 
            procesamientoEnLinea, usuarioInterno, usuarioExterno, idOrigenSistema)
    SELECT @NuevoEstudio, nombreAplicacion, procesoNegocioApoyo, objetivoAplicacion, informacionManeja, 
            entradaAplicacion, salidaAplicacion, proveedorAplicacion, clienteAplicacion, normatividadInterna, normatividadExterna, 
            indicador, fechaInicioProyecto, duracionProyecto, costoProyecto, jefeProyecto, participante, procesamientoPorLotes, 
            procesamientoEnLinea, usuarioInterno, usuarioExterno, idOrigenSistema
      FROM Aplicacion
     WHERE idEstudio = @idEstudio

    -- Etapa 2.2.2
    INSERT INTO EstudioArea(idEstudio, idArea, idRiesgo, proteccionExistenteMonitoreo, riesgoResidualMonitoreo, idProteccionEmpresaMonitoreo, idUsuario, seleccionImprimir, idProteccionEmpresaAuditoria, proteccionExistenteAuditoria, riesgoResidualAuditoria)
    SELECT @NuevoEstudio, idArea, idRiesgo, proteccionExistenteMonitoreo, riesgoResidualMonitoreo, idProteccionEmpresaMonitoreo, idUsuario, seleccionImprimir, idProteccionEmpresaAuditoria, proteccionExistenteAuditoria, riesgoResidualAuditoria
      FROM EstudioArea
     WHERE idEstudio = @idEstudio

    -- Etapa 2.3
    INSERT INTO CifrasCriticas(descripcion, detalle, tipoDato, idEstudio, idEmpresa)
    SELECT descripcion, detalle, tipoDato, @NuevoEstudio, idEmpresa
      FROM CifrasCriticas
     WHERE idEstudio = @idEstudio

    -- Etapa 3.1.
    INSERT INTO RangoImpacto (valorDe, valorHasta, idEstudio, idImpactoCategoria)
    SELECT valorDe, valorHasta, @nuevoEstudio, idImpactoCategoria
      FROM RangoImpacto
     WHERE idEstudio = @idEstudio

    INSERT INTO EstudioCategoria (idEstudio, idCategoriaRiesgo, idRangoImpacto, idRiesgo, idProteccionEmpresaMonitoreo, 
            fechaEvaluacion, posicionCategoria, puntajeObtenido, porcentajeObtenido, promedioImpacto, seleccionCategoria, 
            proteccionExistenteMonitoreo, riesgoResidualMonitoreo, idUsuario, idProteccionEmpresaAuditoria, 
            proteccionExistenteAuditoria, riesgoResidualAuditoria)
    SELECT @NuevoEstudio, idCategoriaRiesgo, 
           (SELECT ri1.idRangoImpacto
              FROM RangoImpacto AS ri
                    INNER JOIN RangoImpacto AS ri1
                    ON ri1.idImpactoCategoria = ri.idImpactoCategoria
             WHERE ri.idEstudio = @idEstudio
               AND ri1.idEstudio = @NuevoEstudio
               AND ri.idRangoImpacto = EstudioCategoria.idRangoImpacto), 
            idRiesgo, idProteccionEmpresaMonitoreo, fechaEvaluacion, 
            posicionCategoria, puntajeObtenido, porcentajeObtenido, promedioImpacto, seleccionCategoria, proteccionExistenteMonitoreo, 
            riesgoResidualMonitoreo, idUsuario, idProteccionEmpresaAuditoria, proteccionExistenteAuditoria, riesgoResidualAuditoria
      FROM EstudioCategoria
     WHERE idEstudio = @idEstudio

    INSERT INTO EstudioControl (idEstudio, idCosto, idControl, idUsuario, totalFactorRedControl, factorCostoCosteado)
    SELECT @NuevoEstudio, NULL, idControl, idUsuario, NULL, NULL
      FROM EstudioControl 
     WHERE idEstudio = @idEstudio

    -- Etapa 3.2: Priorizacin Delphy
    INSERT INTO Delphy (idEstudioCategoria, estIdEstudioCategoria, valorVertical, valorHorizontal, idEstudio)
    SELECT (SELECT idEstudioCategoria 
              FROM EstudioCategoria
             WHERE idEstudio = @NuevoEstudio
               AND idCategoriaRiesgo = ec.idCategoriaRiesgo),
           (SELECT idEstudioCategoria 
              FROM EstudioCategoria
             WHERE idEstudio = @nuevoEstudio
               AND idCategoriaRiesgo = ec1.idCategoriaRiesgo),
           Delphy.valorVertical, Delphy.valorHorizontal, @nuevoEstudio
      FROM Delphy 
            INNER JOIN EstudioCategoria ec 
            ON ec.idEstudioCategoria = delphy.idEstudioCategoria
            INNER JOIN EstudioCategoria ec1 
            ON ec1.idEstudioCategoria = delphy.estIdEstudioCategoria
     WHERE Delphy.idEstudio = @idEstudio

    -- Etapa 3.2: Priorizacin Churmann
    INSERT INTO Calificacion (idEstudio, idEstudioCategoria, idImpacto, numeroVoto, total)
    SELECT @nuevoEstudio, 
           (SELECT ec1.idEstudioCategoria 
              FROM EstudioCategoria AS ec
                    INNER JOIN EstudioCategoria AS ec1 
                    ON ec.idCategoriaRiesgo = ec1.idCategoriaRiesgo
             WHERE ec.idEstudio = @idEstudio
               AND ec1.idEstudio = @nuevoEstudio
               AND ec.idEstudioCategoria = Calificacion.idEstudioCategoria),
           Calificacion.idImpacto, Calificacion.numeroVoto, Calificacion.total
      FROM Calificacion
            INNER JOIN EstudioCategoria 
            ON EstudioCategoria.idEstudioCategoria = Calificacion.idEstudioCategoria
     WHERE Calificacion.idEstudio = @idEstudio

    -- Etapa 3.4
    INSERT INTO EstudioAmenaza (idEmpresa, idEstudio, idAmenaza, valorTotalActivo, idProteccionEmpresa, consecuenciaOrganizacion, idFrecuencia, idRango, idTipoRiesgo, idRiesgoInherente, seleccion, tieneControl, idFrecuenciaDDControles, idRangoDDControles, idRiesgoDDControles, factorExposicionAntesControl, factorExposicionDespuesControl, perdidaSimpleAdCtrl, 
        perdidaSimpleDdCtrl, perdidaAnualAdCtrl, perdidaAnualDdCtrl, costoTotalControl, beneficioSeguridad, reduccionAmenaza, proteccionExistenteMonitoreo, riesgoResidualMonitoreo, idProteccionEmpresaMonitoreo, idPorcentajeMonitoreo, idUsuario, idProteccionEmpresaAuditoria, proteccionExistenteAuditoria, riesgoResidualAuditoria, idPorcentajeAuditoria)
    SELECT idEmpresa, @NuevoEstudio, idAmenaza, valorTotalActivo, NULL, consecuenciaOrganizacion, idFrecuencia, idRango, idTipoRiesgo, idRiesgoInherente, seleccion, tieneControl, idFrecuenciaDDControles, idRangoDDControles, idRiesgoDDControles, factorExposicionAntesControl, factorExposicionDespuesControl, perdidaSimpleAdCtrl, 
        perdidaSimpleDdCtrl, perdidaAnualAdCtrl, perdidaAnualDdCtrl, costoTotalControl, beneficioSeguridad, reduccionAmenaza, proteccionExistenteMonitoreo, riesgoResidualMonitoreo, idProteccionEmpresaMonitoreo, idPorcentajeMonitoreo, idUsuario, idProteccionEmpresaAuditoria, proteccionExistenteAuditoria, riesgoResidualAuditoria, idPorcentajeAuditoria
      FROM EstudioAmenaza
     WHERE idEstudio = @idEstudio

    INSERT INTO RiesgoAmenazaEstudio (idEstudioCategoria, idRiesgoAmenaza)
    SELECT (SELECT ec.idEstudioCategoria 
              FROM EstudioCategoria AS ec
             WHERE ec.idEstudio = @nuevoEstudio
               AND ec.idCategoriaRiesgo = EstudioCategoria.idCategoriaRiesgo),
           RiesgoAmenazaEstudio.idRiesgoAmenaza
      FROM RiesgoAmenazaEstudio
            INNER JOIN EstudioCategoria
            ON EstudioCategoria.idEstudioCategoria = RiesgoAmenazaEstudio.idEstudioCategoria
     WHERE EstudioCategoria.idEstudio = @idEstudio

    -- Ojo adicionado ltimamente ...
    INSERT INTO EstudioAmenazaControl (idEstudioAmenaza, idAmenazaControl, seleccion, costoAdquisicion, costoOperacional, 
	   costoInstalacion, costoMantenimiento, costoTotControl, aporteControl, factorRedControl, Estado_ByPass)
    SELECT (SELECT ea.idEstudioAmenaza
                  FROM EstudioAmenaza AS ea
                 WHERE ea.idEstudio = @nuevoEstudio
                   AND ea.idAmenaza = EstudioAmenaza.idAmenaza), 
	    EstudioAmenazaControl.idAmenazaControl, 
            NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL
      FROM EstudioAmenazaControl
            INNER JOIN EstudioAmenaza
            ON EstudioAmenazaControl.idEstudioAmenaza = EstudioAmenaza.idEstudioAmenaza
     WHERE EstudioAmenaza.idEstudio = @idEstudio

    -- Etapa 3.5
    INSERT INTO EstudioAmenazaActivo (idEstudioAmenaza, idActivo)
    SELECT (SELECT ea.idEstudioAmenaza
              FROM EstudioAmenaza AS ea
             WHERE ea.idEstudio = @nuevoEstudio
               AND ea.idAmenaza = EstudioAmenaza.idAmenaza),
           EstudioAmenazaActivo.idActivo
      FROM EstudioAmenazaActivo
            INNER JOIN EstudioAmenaza
            ON EstudioAmenaza.idEstudioAmenaza = EstudioAmenazaActivo.idEstudioAmenaza
     WHERE EstudioAmenaza.idEstudio = @idEstudio

    INSERT INTO EstudioAmenazaAgente (idEstudioAmenaza, idAgente)
    SELECT (SELECT ea.idEstudioAmenaza
              FROM EstudioAmenaza AS ea
             WHERE ea.idEstudio = @nuevoEstudio
               AND ea.idAmenaza = EstudioAmenaza.idAmenaza),
           EstudioAmenazaAgente.idAgente
      FROM EstudioAmenazaAgente
            INNER JOIN EstudioAmenaza
            ON EstudioAmenaza.idEstudioAmenaza = EstudioAmenazaAgente.idEstudioAmenaza
     WHERE EstudioAmenaza.idEstudio = @idEstudio

    INSERT INTO EstudioAmenazaArea (idEstudioAmenaza, idEstudioArea, proteccionExistenteMonitoreo, riesgoResidualMonitoreo, 
        idProteccionEmpresaMonitoreo, proteccionExistenteAuditoria, riesgoResidualAuditoria, idProteccionEmpresaAuditoria)
    SELECT (SELECT ea.idEstudioAmenaza
              FROM EstudioAmenaza AS ea
             WHERE ea.idEstudio = @nuevoEstudio
               AND ea.idAmenaza = EstudioAmenaza.idAmenaza), 
           (SELECT ea1.idEstudioArea
              FROM EstudioArea AS ea
                    INNER JOIN EstudioArea AS ea1
                    ON ea.idArea = ea1.idArea
             WHERE ea.idEstudio = @idEstudio
               AND ea1.idEstudio = @nuevoEstudio
               AND ea.idEstudioArea = EstudioAmenazaArea.idEstudioArea),
           EstudioAmenazaArea.proteccionExistenteMonitoreo, EstudioAmenazaArea.riesgoResidualMonitoreo, EstudioAmenazaArea.idProteccionEmpresaMonitoreo, 
           EstudioAmenazaArea.proteccionExistenteAuditoria, EstudioAmenazaArea.riesgoResidualAuditoria, EstudioAmenazaArea.idProteccionEmpresaAuditoria
      FROM EstudioAmenazaArea
            INNER JOIN EstudioAmenaza
            ON EstudioAmenaza.idEstudioAmenaza = EstudioAmenazaArea.idEstudioAmenaza
     WHERE EstudioAmenaza.idEstudio = @idEstudio

    INSERT INTO EstudioAmenazaEscenario (idEstudioAmenaza, idEstudioEscenario, criterio1, criterio2, criterio3, criterio4, idProteccionEmpresa,
            idEficiencia, promedioClaseControl, tieneControl, idUsuario)
    SELECT (SELECT ea.idEstudioAmenaza
              FROM EstudioAmenaza AS ea
             WHERE ea.idEstudio = @nuevoEstudio
               AND ea.idAmenaza = EstudioAmenaza.idAmenaza), 
           (SELECT ee1.idEstudioEscenario
              FROM EstudioEscenario AS ee
                    INNER JOIN Escenario AS e
                    ON e.idEscenario = ee.idEscenario
                    INNER JOIN Escenario AS e1
                    ON e1.descripcionEscenario = e.descripcionEscenario
                    INNER JOIN EstudioEscenario AS ee1
                    ON ee1.idEscenario = e1.idEscenario
             WHERE ee.idEstudio = @idEstudio
               AND ee1.idEstudio = @nuevoEstudio
               AND ee.idEstudioEscenario = EstudioAmenazaEscenario.idEstudioEscenario),
           NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, @idUsuario
      FROM EstudioAmenazaEscenario
            INNER JOIN EstudioAmenaza
            ON EstudioAmenaza.idEstudioAmenaza = EstudioAmenazaEscenario.idEstudioAmenaza
     WHERE EstudioAmenaza.idEstudio = @idEstudio

    INSERT INTO EstudioAmenazaVulnerabilidad (idEstudioAmenaza, idVulnerabilidad)
    SELECT (SELECT ea.idEstudioAmenaza
              FROM EstudioAmenaza AS ea
             WHERE ea.idEstudio = @nuevoEstudio
               AND ea.idAmenaza = EstudioAmenaza.idAmenaza),
           EstudioAmenazaVulnerabilidad.idVulnerabilidad
      FROM EstudioAmenazaVulnerabilidad
            INNER JOIN EstudioAmenaza
            ON EstudioAmenaza.idEstudioAmenaza = EstudioAmenazaVulnerabilidad.idEstudioAmenaza
     WHERE EstudioAmenaza.idEstudio = @idEstudio

    INSERT INTO IncidenteSeguridad (descripcionIncidente, idEstudioAmenaza, fechaOcurrencia)
    SELECT IncidenteSeguridad.descripcionIncidente, 
            (SELECT ea.idEstudioAmenaza
              FROM EstudioAmenaza AS ea
             WHERE ea.idEstudio = @nuevoEstudio
               AND ea.idAmenaza = EstudioAmenaza.idAmenaza),
           IncidenteSeguridad.fechaOcurrencia
      FROM IncidenteSeguridad
            INNER JOIN EstudioAmenaza
            ON EstudioAmenaza.idEstudioAmenaza = IncidenteSeguridad.idEstudioAmenaza
     WHERE EstudioAmenaza.idEstudio = @idEstudio

    INSERT INTO CriterioImpactoEstudioAmenaza (idRango, idEstudioAmenaza, momento, valorImpacto, idRangoElegido)
    SELECT CriterioImpactoEstudioAmenaza.idRango, 
           (SELECT ea.idEstudioAmenaza
              FROM EstudioAmenaza AS ea
             WHERE ea.idEstudio = @nuevoEstudio
               AND ea.idAmenaza = EstudioAmenaza.idAmenaza),
           CriterioImpactoEstudioAmenaza.momento, CriterioImpactoEstudioAmenaza.valorImpacto, CriterioImpactoEstudioAmenaza.idRangoElegido
      FROM CriterioImpactoEstudioAmenaza
            INNER JOIN EstudioAmenaza
            ON EstudioAmenaza.idEstudioAmenaza = CriterioImpactoEstudioAmenaza.idEstudioAmenaza
     WHERE EstudioAmenaza.idEstudio = @idEstudio

    -- Etapa 3.8
    INSERT INTO EstudioAmenazaAlternativa (idEstudioAmenaza, idAlternativa)
    SELECT (SELECT ea.idEstudioAmenaza
              FROM EstudioAmenaza AS ea
             WHERE ea.idEstudio = @nuevoEstudio
               AND ea.idAmenaza = EstudioAmenaza.idAmenaza),
           EstudioAmenazaAlternativa.idAlternativa
      FROM EstudioAmenazaAlternativa
            INNER JOIN EstudioAmenaza
            ON EstudioAmenaza.idEstudioAmenaza = EstudioAmenazaAlternativa.idEstudioAmenaza
     WHERE EstudioAmenaza.idEstudio = @idEstudio

    -- Etapa 4.5: 
    INSERT INTO EscenarioObjetivo (idEscenario, idObjetivo)
    SELECT (SELECT e1.idEscenario
              FROM Escenario AS e
                   INNER JOIN Escenario AS e1
                   ON e1.descripcionEscenario = e.descripcionEscenario
            WHERE e.idEstudio = @idEstudio
              AND e1.idEstudio = @NuevoEstudio
              AND e.idEscenario = EscenarioObjetivo.idEscenario),
           EscenarioObjetivo.idObjetivo
      FROM EscenarioObjetivo
            INNER JOIN EscenarioObjetivoEstudio
            ON EscenarioObjetivo.idEscenarioObjetivo = EscenarioObjetivoEstudio.idEscenarioObjetivo
            INNER JOIN EstudioEscenario 
            ON EstudioEscenario.idEstudioEscenario = EscenarioObjetivoEstudio.idEstudioEscenario
     WHERE EstudioEscenario.idEstudio = @idEstudio
       AND (SELECT e1.idEscenario
              FROM Escenario AS e
                   INNER JOIN Escenario AS e1
                   ON e1.descripcionEscenario = e.descripcionEscenario
            WHERE e.idEstudio = @idEstudio
              AND e1.idEstudio = @NuevoEstudio
              AND e.idEscenario = EscenarioObjetivo.idEscenario) IS NOT NULL

    INSERT INTO EscenarioObjetivoEstudio (idEstudioEscenario, idEscenarioObjetivo, idProteccionEmpresa)
    SELECT (SELECT ee1.idEstudioEscenario
              FROM EstudioEscenario AS ee
                    INNER JOIN Escenario AS e
                    ON e.idEscenario = ee.idEscenario
                    INNER JOIN Escenario AS e1
                    ON e1.descripcionEscenario = e.descripcionEscenario
                    INNER JOIN EstudioEscenario AS ee1
                    ON ee1.idEscenario = e1.idEscenario
             WHERE ee.idEstudio = @idEstudio
               AND ee1.idEstudio = @NuevoEstudio
               AND ee.idEstudioEscenario = EstudioEscenario.idEstudioEscenario ),       
           EscenarioObjetivoEstudio.idEscenarioObjetivo, EscenarioObjetivoEstudio.idProteccionEmpresa
      FROM EscenarioObjetivoEstudio 
            INNER JOIN EstudioEscenario
            ON EstudioEscenario.idEstudioEscenario = EscenarioObjetivoEstudio.idEstudioEscenario
     WHERE EstudioEscenario.idEstudio = @idEstudio

    -- Etapa 4.6
--    DROP TABLE #tmpEstudioAmenazaEscenario
--    DROP TABLE #tmpEscenarioObjetivoEstudio

    CREATE TABLE #tmpEstudioAmenazaEscenario (
        ant_EstudioAmenazaEscenario Int NOT NULL,
        nue_EstudioAmenazaEscenario Int NOT NULL,
        ant_EstudioAmenaza Int NOT NULL,
        nue_EstudioAmenaza Int NOT NULL,
        ant_EstudioEscenario Int NOT NULL,
        nue_EstudioEscenario Int NOT NULL 
    )

    CREATE TABLE #tmpEscenarioObjetivoEstudio (
        ant_EscenarioObjetivoEstudio Int NOT NULL,
        nue_EscenarioObjetivoEstudio Int NOT NULL,
        ant_EstudioEscenario Int NOT NULL,
        nue_EstudioEscenario Int NOT NULL,
        idEscenarioObjetivo Int NOT NULL )

    INSERT INTO #tmpEstudioAmenazaEscenario
    SELECT EstudioAmenazaEscenario.idEstudioAmenazaEscenario, 0, EstudioAmenazaEscenario.idEstudioAmenaza, 
           ea1.idEstudioAmenaza, EstudioAmenazaEscenario.idEstudioEscenario, 
           (SELECT ee1.idEstudioEscenario
              FROM EstudioEscenario AS ee
                    INNER JOIN Escenario AS e
                    ON e.idEscenario = ee.idEscenario
                    INNER JOIN Escenario AS e1
                    ON e1.descripcionEscenario = e.descripcionEscenario
                    INNER JOIN EstudioEscenario AS ee1
                    ON ee1.idEscenario = e1.idEscenario
             WHERE ee.idEstudio = @idEstudio
               AND ee1.idEstudio = @NuevoEstudio
               AND ee.idEstudioEscenario = EstudioAmenazaEscenario.idEstudioEscenario)
     FROM EstudioAmenazaEscenario 
            INNER JOIN EstudioAmenaza ea 
            ON ea.idEstudioAmenaza = EstudioAmenazaEscenario.idEstudioAmenaza 
            INNER JOIN EstudioAmenaza ea1 
            ON ea.idAmenaza = ea1.idAmenaza
      WHERE ea.idEstudio = @idEstudio
        AND ea1.idEstudio = @nuevoEstudio   


    UPDATE #tmpEstudioAmenazaEscenario
       SET nue_EstudioAmenazaEscenario = (
                        SELECT EstudioAmenazaEscenario.idEstudioAmenazaEscenario
                          FROM EstudioAmenazaEscenario 
                                INNER JOIN EstudioAmenaza 
                                ON EstudioAmenazaEscenario.idEstudioAmenaza = EstudioAmenaza.idEstudioAmenaza
                         WHERE EstudioAmenaza.idEstudio = @nuevoEstudio
                           AND EstudioAmenazaEscenario.idEstudioAmenaza = #tmpEstudioAmenazaEscenario.nue_EstudioAmenaza
                           AND EstudioAmenazaEscenario.idEstudioEscenario = #tmpEstudioAmenazaEscenario.nue_EstudioEscenario)

    INSERT INTO #tmpEscenarioObjetivoEstudio 
    SELECT EscenarioObjetivoEstudio.idEscenarioObjetivoEstudio, 0, EscenarioObjetivoEstudio.idEstudioEscenario,
           (SELECT ee1.idEstudioEscenario
              FROM EstudioEscenario AS ee
                    INNER JOIN Escenario AS e
                    ON e.idEscenario = ee.idEscenario
                    INNER JOIN Escenario AS e1
                    ON e1.descripcionEscenario = e.descripcionEscenario
                    INNER JOIN EstudioEscenario AS ee1
                    ON ee1.idEscenario = e1.idEscenario
             WHERE ee.idEstudio = @idEstudio
               AND ee1.idEstudio = @NuevoEstudio
               AND ee.idEstudioEscenario = EstudioEscenario.idEstudioEscenario),
           EscenarioObjetivoEstudio.idEscenarioObjetivo
      FROM EscenarioObjetivoEstudio
            INNER JOIN EstudioEscenario 
            ON EstudioEscenario.idEstudioEscenario = EscenarioObjetivoEstudio.idEstudioEscenario
     WHERE EstudioEscenario.idEstudio = @idEstudio

    UPDATE #tmpEscenarioObjetivoEstudio
       SET nue_EscenarioObjetivoEstudio = (
                            SELECT EscenarioObjetivoEstudio.idEscenarioObjetivoEstudio
                              FROM EscenarioObjetivoEstudio
                                    INNER JOIN EstudioEscenario 
                                    ON EstudioEscenario.idEstudioEscenario = EscenarioObjetivoEstudio.idEstudioEscenario
                             WHERE EstudioEscenario.idEstudio = @nuevoEstudio  
                               AND EscenarioObjetivoEstudio.idEstudioEscenario = #tmpEscenarioObjetivoEstudio.nue_EstudioEscenario
                               AND EscenarioObjetivoEstudio.idEscenarioObjetivo = #tmpEscenarioObjetivoEstudio.idEscenarioObjetivo )

    INSERT INTO EstudioAmenazaObjetivo (idEscenarioObjetivoEstudio, idEstudioAmenazaEscenario)
    SELECT (SELECT nue_EscenarioObjetivoEstudio 
              FROM #tmpEscenarioObjetivoEstudio
             WHERE ant_EscenarioObjetivoEstudio = EstudioAmenazaObjetivo.idEscenarioObjetivoEstudio),
           (SELECT nue_EstudioAmenazaEscenario
              FROM #tmpEstudioAmenazaEscenario
             WHERE ant_EstudioAmenazaEscenario = EstudioAmenazaObjetivo.idEstudioAmenazaEscenario)
      FROM EstudioEscenario
            INNER JOIN EscenarioObjetivoEstudio
            ON EstudioEscenario.idEstudioEscenario = EscenarioObjetivoEstudio.idEstudioEscenario
            INNER JOIN EstudioAmenazaObjetivo
            ON EstudioAmenazaObjetivo.idEscenarioObjetivoEstudio = EscenarioObjetivoEstudio.idEscenarioObjetivoEstudio
     WHERE EstudioEscenario.idEstudio = @idEstudio

COMMIT TRANSACTION
END TRY

BEGIN CATCH
    ROLLBACK TRANSACTION;
    IF (XACT_STATE()) = -1 ROLLBACK TRANSACTION;
    SET @Mensaje = ERROR_LINE()
    RAISERROR (@Mensaje, 16, 1) WITH NOWAIT
END CATCH;

GO
------------------------------------------------------------------------------------------
-- Fin Script 21 JUNIO 2012 Carolina Olarte	                  	                        --
------------------------------------------------------------------------------------------

-----------------------------------------------------------------------------------------------------
-- Inicio Script 26 Junio 2012 Carolina Olarte 	                                                   --
-- Ajuste Rastros de Base de Datos                                                                 --
-----------------------------------------------------------------------------------------------------

UPDATE menu
SET enlace = '~/Configuracion/RastrosCambiosBD.aspx'
WHERE idMenu = '0403020302'



UPDATE pagina
SET idMenu = '0403020302'
WHERE nombre like 'RastrosCambiosBD.aspx%'


INSERT INTO PaginaPerfil (idPagina,idPerfil)
select idPagina,13
from pagina 
where idMenu = '0403020302'

INSERT INTO PaginaPerfil (idPagina,idPerfil)
select idPagina,18
from pagina 
where idMenu = '0403020302'

------------------------------------------------------------------------------------------
-- Fin Script 26 JUNIO 2012 Carolina Olarte	                  	                        --
------------------------------------------------------------------------------------------